C Output from Public domain Ratfor, version 1.0
      subroutine getlam(n,p,x,sx,lambda,order,dist,ns,s,strech,vecx,temp
     *sx)
      integer n,p,ns,order(n)
      double precision x(n,p),sx(n,p),s(ns,p),lambda(n),dist(n),tempsx(p
     *), vecx(p),strech
      if(strech .lt. 0d0)then
      strech=0d0
      endif
      if(strech .gt. 2d0)then
      strech=2d0
      endif
      do23004 j=1,p
      s(1,j)=s(1,j)+strech*(s(1,j)-s(2,j))
      s(ns,j)=s(ns,j)+strech*(s(ns,j)-s(ns-1,j))
23004 continue
23005 continue
      do23006 i=1,n
      do23008 j=1,p 
      vecx(j)=x(i,j)
23008 continue
23009 continue
      call lamix(ns,p,vecx,s,lambda(i),dist(i),tempsx)
      do23010 j=1,p 
      sx(i,j)=tempsx(j)
23010 continue
23011 continue
23006 continue
23007 continue
      do23012 i=1,n
      order(i)=i
23012 continue
23013 continue
      call sortdi(lambda,order,1,n)
      call newlam(n,p,sx,lambda,order)
      return
      end
      subroutine newlam(n,p,sx,lambda,tag)
      integer n,p,tag(n)
      double precision sx(n,p),lambda(n),lami
      lambda(tag(1))=0d0
      i=1
23014 if(.not.(i.lt.n))goto 23016
      lami=0d0
      do23017 j=1,p
      lami=lami+(sx(tag(i+1),j)-sx(tag(i),j))**2
23017 continue
23018 continue
      lambda(tag(i+1))=lambda(tag(i))+dsqrt(lami)
23015 i=i+1
      goto 23014
23016 continue
      return
      end
      subroutine lamix(ns,p,x,s,lambda,dismin,temps)
      integer ns,p
      double precision lambda,x(p),s(ns,p),temps(p)
      double precision v(2,10),d1sqr,d2sqr,dismin,d12,dsqr, d1,w
      real lam,lammin
      integer left,right
      dismin=1d60
      lammin=1
      ik = 1
23019 if(.not.(ik.lt.ns))goto 23021
      d1sqr=0.0
      d2sqr=0.0
      do23022 j=1,p
      v(2,j)=x(j)-s(ik,j)
      v(1,j)=s(ik+1,j)-s(ik,j)
      d1sqr=d1sqr+v(1,j)**2
      d2sqr=d2sqr+v(2,j)**2
23022 continue
23023 continue
      if(d1sqr.lt.1d-8*d2sqr)then
      lam=ik
      dsqr=d2sqr
      else
      d12=0d0
      do23026 j=1,p
      d12 = d12+v(1,j)*v(2,j)
23026 continue
23027 continue
      d1=d12/d1sqr
      if(d1.gt.1d0)then
      lam=ik+1
      dsqr=d1sqr+d2sqr-2d0*d12
      else
      if(d1.lt.0.0)then
      lam=ik
      dsqr=d2sqr
      else
      lam=ik+(d1)
      dsqr=d2sqr-(d12**2)/d1sqr
      endif
      endif
      endif
      if(dsqr.lt.dismin)then
      dismin=dsqr
      lammin=lam
      endif
23020 ik=ik+1
      goto 23019
23021 continue
      left=lammin
      if(lammin.ge.ns)then
      left=ns-1
      endif
      right=left+1
      w=dble(lammin-left)
      do23036 j=1,p
      temps(j)=(1d0-w)*s(left,j)+w*s(right,j)
23036 continue
23037 continue
      lambda=dble(lammin)
      return
      end
      subroutine sortdi (v,a,ii,jj)
c
c     puts into a the permutation vector which sorts v into
c     increasing order.  only elements from ii to jj are considered.
c     arrays iu(k) and il(k) permit sorting up to 2**(k+1)-1 elements
c     v is returned sorted
c     this is a modification of cacm algorithm #347 by r. c. singleton,
c     which is a modified hoare quicksort.
c
      integer t,tt,ii,jj,iu(20),il(20)
      integer a(jj)
      double precision v(1), vt, vtt
      m=1
      i=ii
      j=jj
 10   if (i.ge.j) go to 80
 20   k=i
      ij=(j+i)/2
      t=a(ij)
      vt=v(ij)
      if (v(i).le.vt) go to 30
      a(ij)=a(i)
      a(i)=t
      t=a(ij)
      v(ij)=v(i)
      v(i)=vt
      vt=v(ij)
 30   l=j
      if (v(j).ge.vt) go to 50
      a(ij)=a(j)
      a(j)=t
      t=a(ij)
      v(ij)=v(j)
      v(j)=vt
      vt=v(ij)
      if (v(i).le.vt) go to 50
      a(ij)=a(i)
      a(i)=t
      t=a(ij)
      v(ij)=v(i)
      v(i)=vt
      vt=v(ij)
      go to 50
 40   a(l)=a(k)
      a(k)=tt
      v(l)=v(k)
      v(k)=vtt
 50   l=l-1
      if (v(l).gt.vt) go to 50
      tt=a(l)
      vtt=v(l)
 60   k=k+1
      if (v(k).lt.vt) go to 60
      if (k.le.l) go to 40
      if (l-i.le.j-k) go to 70
      il(m)=i
      iu(m)=l
      i=k
      m=m+1
      go to 90
 70   il(m)=k
      iu(m)=j
      j=l
      m=m+1
      go to 90
 80   m=m-1
      if (m.eq.0) return
      i=il(m)
      j=iu(m)
 90   if (j-i.gt.10) go to 20
      if (i.eq.ii) go to 10
      i=i-1
 100  i=i+1
      if (i.eq.j) go to 80
      t=a(i+1)
      vt=v(i+1)
      if (v(i).le.vt) go to 100
      k=i
 110  a(k+1)=a(k)
      v(k+1)=v(k)
      k=k-1
      if (vt.lt.v(k)) go to 110
      a(k+1)=t
      v(k+1)=vt
      go to 100
      end
